/*  GP2Xengine 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/


/*
	Portable PC-Engine Emulator
	1998 by BERO bero@geocities.co.jp

    Modified 1998 by hmmx hmmx@geocities.co.jp
	Modified 1999-2005 by Zeograd (Olivier Jolly) zeograd@zeograd.com
	Modified 2005 by Hermes/PS2Reality
*/


#include	<stdio.h>
#include	<stdlib.h>
#include	"m6502.h"
#include	"pce.h"
#include	"bzip/bzlib.h"


#include	"sound.h"
#include    "wav.h"
#include	"iso.h"


#define BOOL int
#define DWORD unsigned
#define WORD unsigned short
#define BYTE byte

int fast_sprite=0;

extern int FPS;
int is_ext(char *a,char *b); // compara extensiones
int StartSound(void); 
int StopSound(void);

extern int never_run_one_rom;
extern int swap_screen;
extern int skip_wave_sound;

char *MY_filename;
M6502 dummy;
M6502 *M2=&dummy;

char back_name_path[256];
int back_name_ext;
char * get_name(char *name);

#ifdef SUPPORT_FOR_ARCADE_CARD
int want_arcade_card_emulation=0;
byte ac_extra_mem[0x200000]  __attribute__((aligned(4)));

#endif

int TRACE(char *a,...) {}

#define WIDTH (320+64)
#define HEIGHT 256




#define Op6502(A) Page[A>>13][A]


int UPeriod;
 int BaseClock;
int min(int a,int b)
 {
 if(a<b) return a;
 return b;
 }

#ifndef TRUE
#define	TRUE	1
#define	FALSE	0
#endif



#define	VRAMSIZE	0x20000


byte RAM[0x8000+0x2000] __attribute__((aligned(4))); // suma 0x2000 por posible desbordamiento
byte PopRAM[0x10000] __attribute__((aligned(4)));


#define	ZW	64
//byte ZBuf[ZW*256];
byte *Page[16],*ROMMap[256];
//BOOL IsROM[8];
byte *VRAM,*ROM,*vchange,*vchanges,*WRAM,/**DMYROM,*/*IOAREA,*IOAREA2;
short SPRAM[64*4] __attribute__((aligned(4)));
void * get_addr(unsigned page)
{
return &ROM[0x2000*page];
}

byte SPM[WIDTH*HEIGHT] __attribute__((aligned(4)));
unsigned long *VRAM2,*VRAMS;
int ROM_size;
extern int Debug,vmode;
int Country=0x30;
int IPeriod;
extern int BaseClock, UPeriod;
//static int TimerCount
extern unsigned CycleOld;
int TimerPeriod;
int scanlines_per_frame  = 263;
int scanline;
#define MinLine	io.minline
#define MaxLine io.maxline
//int MinLine = 0,MaxLine = 255;
#define MAXDISP	234 //227
byte BGONSwitch = 1, SPONSwitch = 1;
char *cart_name;
byte cart_reload;
byte populus = 0;
int scroll = 0;

byte Pal[512] __attribute__((aligned(4)));

IO io;

int rom_need_decrypt=0;
int watch_dog=0;
void decrypt_rom()
{
int n;
unsigned char v,v2;

rom_need_decrypt=0;    

    for (n = 0; n < (ROM_size * 0x2000);n++)
	{
	v = ROM[n];
	v2=0;
	if(v & 128) v2|=1;
	if(v &  64) v2|=2;
	if(v &  32) v2|=4;
	if(v &  16) v2|=8;
	if(v &   8) v2|=16;
	if(v &   4) v2|=32;
	if(v &   2) v2|=64;
	if(v &   1) v2|=128;
	ROM[n]=v2; 
	}

}
extern BOOL snd_bSound;

#define	VRR	2
enum _VDC_REG {
	MAWR,MARR,VWR,vdc3,vdc4,CR,RCR,BXR,
	BYR,MWR,HSR,HDR,VPR,VDW,VCR,DCR,
	SOUR,DISTR,LENR,SATB};
#define	NODATA	0xff
#define	ENABLE	1
#define	DISABLE	0

#define	VDC_CR	0x01
#define	VDC_OR	0x02
#define	VDC_RR	0x04
#define	VDC_DS	0x08
#define	VDC_DV	0x10
#define	VDC_VD	0x20
#define	VDC_BSY	0x40
#define	VDC_SpHit	VDC_CR
#define	VDC_Over	VDC_OR
#define	VDC_RasHit	VDC_RR
#define	VDC_InVBlank VDC_VD
#define	VDC_DMAfinish	VDC_DV
#define	VDC_SATBfinish	VDC_DS

#define	SpHitON		(io.VDC[CR].W&0x01)
#define	OverON		(io.VDC[CR].W&0x02)
#define	RasHitON	(io.VDC[CR].W&0x04)
#define	VBlankON	(io.VDC[CR].W&0x08)
#define	SpriteON	(io.VDC[CR].W&0x40)
#define	ScreenON	(io.VDC[CR].W&0x80)

#define SATBIntON	(io.VDC[DCR].W&0x01)
#define DMAIntON	(io.VDC[DCR].W&0x02)

#define	IRQ2	1
#define	IRQ1	2
#define	TIRQ	4

//#define ScrollX	io.scroll_x
//#define ScrollY io.scroll_y
#define	ScrollX	io.VDC[BXR].W
#define	ScrollY	io.VDC[BYR].W
int ScrollYDiff;
int	oldScrollX;
int	oldScrollY;
int	oldScrollYDiff;

typedef struct {
	short y,x,no,atr;
} SPR;


int CheckSprites(void);
int JoyStick(void);

void  IO_write(word A,byte V);
byte  IO_read(word A);
void RefreshLine(int Y1,int Y2);
void RefreshSprite(int Y1,int Y2,BYTE bg);
void RefreshScreen(void);

void bank_set(byte P,byte V)
{

	

	if (V>=ROM_size && V<0xF7) {
	//	printf("ignore bank set %x:%02x",P,V);
	//	TrashMachine();
	//	exit(-1);
	
	}
	if (ROMMap[V]==IOAREA)
	{
//	IOAREA2=IOAREA-P*0x2000;
	Page[P]=IOAREA2;
	}
	else
	{
	
	Page[P]=ROMMap[V]-P*0x2000;
	 
	}
//	IsROM[P] = (V < 0xF7);
}

/*
byte _Rd6502(word A)
{
	if (Page[A>>13]!=IOAREA) return Page[A>>13][A];
	else return IO_read(A);
}

void _Wr6502(word A,byte V)
{
	if (Page[A>>13]!=IOAREA)
	{

			Page[A>>13][A]=V;
	}
	else IO_write(A,V);
}
*/

/* write */
	

#ifdef _DEBUG
void DebugDumpTrace(int nMemDump, BOOL bDispStack)
{
	int		i;

//	TRACE("PC=%04X, A=%02X,X=%02X,Y=%02X, S=%02X\n", M.PC.W, M.A, M.X, M.Y, M.S);
//	TRACE0("Page=");
	for (i = 0; i < 8; i++)
		//TRACE("%02X ", M.MPR[i]);
	if (nMemDump > 0)
	{
		//TRACE0("\nMem=");
		for (i = -8; i < nMemDump; i++)
			TRACE("%02X ", Page[(M.PC.W+i)>>13][M.PC.W+i]);
		TRACE0("\n");
	}
	if (bDispStack)
	{
		//TRACE0("Stack=");
		for (i = M.S+1; i <= 0xFF; i++)
			TRACE("%02X ", Page[1][0x2100+i]);
		//TRACE0("\n");
	}
}

FILE	*fp;
void DebugDumpFp(int nMemDump, BOOL bDispStack)
{
	int		i;

	if (fp == NULL)
		fp = fopen("c:\\temp.out", "w");

	fprintf(fp, "PC=%04X, A=%02X,X=%02X,Y=%02X, S=%02X\n", M.PC.W, M.A, M.X, M.Y, M.S);
	fprintf(fp, "Page=");
	for (i = 0; i < 8; i++)
		fprintf(fp, "%02X ", M.MPR[i]);
	if (nMemDump > 0)
	{
		fprintf(fp, "\nMem=");
		for (i = -8; i < nMemDump; i++)
			fprintf(fp, "%02X ", Page[(M.PC.W+i)>>13][M.PC.W+i]);
		fprintf(fp, "\n");
	}
	if (bDispStack)
	{
		fprintf(fp, "Stack=");
		for (i = M.S+1; i <= 0xFF; i++)
			fprintf(fp, "%02X ", Page[1][0x2100+i]);  
		fprintf(fp, "\n");
	}
}
#endif // _DEBUG

void  inline IO_write(word A,byte V)
{
	//printf("w%04x,%02x ",A&0x3FFF,V);
  switch(A&0x1F00) {
  case 0x0000:	/* VDC */
	switch(A&3){
	case 0: io.vdc_reg = V&31; return;
	case 1: return;
	case 2:
		//printf("vdc_l%d,%02x ",io.vdc_reg,V);
		switch(io.vdc_reg){
		case VWR:
			/*VRAM[io.VDC[MAWR].W*2] = V;*/ io.vdc_ratch = V;
			//io.VDC_ratch[VWR] = V;
/*			if (0x1000 <= io.VDC[MAWR].W && io.VDC[MAWR].W < 0x1008)
			{
				TRACE("L: PC = %X, ", M.PC.W);
				for (int i = -10; i < 4; i++)
					TRACE("%02X ", Page[(M.PC.W+i)>>13][M.PC.W+i]);
				TRACE("\nL: V[%X] = %X\n", io.VDC[MAWR].W, V);
			}
*/			return;
		case HDR:
			io.screen_w = (V+1)<<3;swap_screen=0;
			//printf("screen:%dx%d %d\n",io.screen_w,256,V);
			//TRACE("HDRl: %X\n", V);
			break;
		case MWR:
			{static byte bgw[]={32,64,128,128};swap_screen=0;
			io.bg_h=(V&0x40)?64:32;
			io.bg_w=bgw[(V>>4)&3];}
			//TRACE("bg:%dx%d, V:%X\n",io.bg_w,io.bg_h, V);
			//TRACE("MWRl: %02X\n", V);
			break;
		case BYR:
			if (!scroll) {
				oldScrollX = ScrollX;
				oldScrollY = ScrollY;
				oldScrollYDiff = ScrollYDiff;
			}
			io.VDC[BYR].B.l = V;
			scroll=1;

			ScrollYDiff=scanline-1;

			return;
		case BXR:
			if (!scroll) {
				oldScrollX = ScrollX;
				oldScrollY = ScrollY;
				oldScrollYDiff = ScrollYDiff;
			}
			io.VDC[BXR].B.l = V;
			scroll=1;
			return;
	#if 0		
#define PRINT_VDC_L(REG)	case REG:break;
//			PRINT_VDC_L(CR);
/*			PRINT_VDC_L(HSR);
*/			PRINT_VDC_L(VPR);
			PRINT_VDC_L(VDW);
			PRINT_VDC_L(VCR);
/*			PRINT_VDC_L(SOUR);
			PRINT_VDC_L(DISTR);
*/			PRINT_VDC_L(DCR);
#endif	
	#if 0
		 case CR:
              if (io.VDC[io.vdc_reg].B.l == V)
                return;
              //save_gfx_context(0);
              io.VDC[io.vdc_reg].B.l = V;
              return;

            case VCR:
              io.VDC[io.vdc_reg].B.l = V;
              //gfx_need_video_mode_change = 1;
              return;

            case HSR:
              io.VDC[io.vdc_reg].B.l = V;
              //gfx_need_video_mode_change = 1;
              return;

            case VPR:
              io.VDC[io.vdc_reg].B.l = V;
              //gfx_need_video_mode_change = 1;
              return;

	    case VDW:
              io.VDC[io.vdc_reg].B.l = V;
              //gfx_need_video_mode_change = 1;
              return;
			  #endif
			
		}
		io.VDC[io.vdc_reg].B.l = V; //io.VDC_ratch[io.vdc_reg] = V;
//		if (io.vdc_reg != CR)
//			TRACE("vdc_l: %02X,%02X\n", io.vdc_reg, V);
		if (io.vdc_reg>19) {
			//TRACE("ignore write lo vdc%d,%02x\n",io.vdc_reg,V);
		}
		return;
	case 3:
		//printf("vdc_h%d,%02x ",io.vdc_reg,V);
		switch(io.vdc_reg){
		case VWR:
			//printf("v%04x\n",io.VDC[MAWR].W);
			VRAM[io.VDC[MAWR].W<<1]=io.vdc_ratch;
			VRAM[(io.VDC[MAWR].W<<1)+1]=V;

			vchange[io.VDC[MAWR].W>>4]=1;
			vchanges[io.VDC[MAWR].W>>6]=1;
			io.VDC[MAWR].W+=io.vdc_inc;
			
			//io.vdc_ratch=0;// modificado
			return;
		case VDW:
			watch_dog=0; // si ajusta el video no creo que se haya colgado..
			//io.VDC[VDW].B.l = io.VDC_ratch[VDW];
			io.VDC[VDW].B.h = V;
			io.screen_h = (io.VDC[VDW].W&511)+1;
			MaxLine = io.screen_h-1;
			//TRACE("VDWh: %X\n", io.VDC[VDW].W);
			return;
		case LENR:
			watch_dog=0; // si programa dma's  no creo que se haya colgado..
		#if 0
			//io.VDC[LENR].B.l = io.VDC_ratch[LENR];
			io.VDC[LENR].B.h = V;
//			TRACE("DMA:%04x %04x %04x\n",io.VDC[DISTR].W,io.VDC[SOUR].W,io.VDC[LENR].W);
			/* VRAM to VRAM DMA */
			memcpy(VRAM+(io.VDC[DISTR].W<<1),VRAM+(io.VDC[SOUR].W<<1),
				(io.VDC[LENR].W+1)<<1);
			memset(vchange+(io.VDC[DISTR].W>>4),1,(io.VDC[LENR].W+1)>>4);
			memset(vchange+(io.VDC[DISTR].W>>6),1,(io.VDC[LENR].W+1)>>6);
			io.VDC[DISTR].W += io.VDC[LENR].W+1;
			io.VDC[SOUR].W += io.VDC[LENR].W+1;
			io.vdc_status|=VDC_DMAfinish;
			#else

			 io.VDC[LENR].B.h = V;

              { // black-- 's code

                int sourcecount = (io.VDC[DCR].W & 8) ? -1 : 1;
                int destcount = (io.VDC[DCR].W & 4) ? -1 : 1;

                int source = io.VDC[SOUR].W * 2;
                int dest = io.VDC[DISTR].W * 2;

                int i;

                for (i = 0; i < (io.VDC[LENR].W + 1) * 2; i++)
                  {
                    *(VRAM + dest) = *(VRAM + source);
                    dest += destcount;
                    source += sourcecount;
                  }

                /*
                  io.VDC[SOUR].W = source;
                  io.VDC[DISTR].W = dest;
                */
                // Erich Kitzmuller fix follows
                io.VDC[SOUR].W = source / 2;
                io.VDC[DISTR].W = dest / 2;

              }

              io.VDC[LENR].W = 0xFFFF;

              memset(vchange, 1, VRAMSIZE / 32);
              memset(vchanges,1, VRAMSIZE / 128);


              /* TODO: check whether this flag can be ignored */
              io.vdc_status |= VDC_DMAfinish;
			  #endif

			return;
		case CR :
			{static byte incsize[]={1,32,64,128};
			io.vdc_inc = incsize[(V>>3)&3];
			 io.VDC[CR].B.h = V;
			//TRACE("CRh: %02X\n", V);
			}
			break;
		case HDR:
			//io.screen_w = (io.VDC_ratch[HDR]+1)*8;
			//TRACE0("HDRh\n");
			break;
		case BYR:
			if (!scroll) {
				oldScrollX = ScrollX;
				oldScrollY = ScrollY;
				oldScrollYDiff = ScrollYDiff;
			}
			io.VDC[BYR].B.h = V&1;
			scroll=1;
//			io.vdc_iswrite_h = 1;
//			if (scanline <= MaxLine)
//			{
				//TRACE("BYRh = %d, scanline = %d, h = %d\n", io.VDC[BYR].W, scanline, io.screen_h);
			//if (RasHitON)
			{
				ScrollYDiff=scanline-1;
				//TRACE("BYRh = %d, scanline = %d, h = %d\n", io.VDC[BYR].W, scanline, io.screen_h);
				//DebugDumpFp(4, TRUE);
			}
//			}
//			else
//				ScrollYDiff=0;
			//ScrollY = 51-35;
			return;
		case SATB:
			io.VDC[SATB].B.h = V;
			//TRACE("SATB=%X,scanline=%d\n", io.VDC[SATB].W, scanline);
			//memcpy(SPRAM,VRAM+io.VDC[SATB].W*2,64*8);
			io.vdc_satb=1;
			io.vdc_status&=~VDC_SATBfinish;
			return;
		case BXR:
			if (io.VDC[BXR].B.h == (V & 3))
                return; // modificado
			if (!scroll) {
				oldScrollX = ScrollX;
				oldScrollY = ScrollY;
				oldScrollYDiff = ScrollYDiff;
			}
			io.VDC[BXR].B.h = V & 3;
			scroll=1;
//			ScrollX = io.VDC[BXR].W;
//			TRACE("BXRh = %d, scanline = %d\n", io.VDC[BXR].W, scanline);
//			io.VDC[BXR].W = 256;
			return;
			
#define PRINT_VDC_H(REG)	case REG: /*TRACE(#REG "h: %X\n",V);*/break;
/*			PRINT_VDC_H(HSR);
			//PRINT_VDC_H(HDR);
*/			PRINT_VDC_H(VPR);
			PRINT_VDC_H(VCR);
/*			PRINT_VDC_H(SOUR);
			PRINT_VDC_H(DISTR);
*/			PRINT_VDC_H(DCR);
		//case RCR: TRACE("RCR: %02X%02X\n", V, io.VDC[io.vdc_reg].B.l);break;

		}
		//io.VDC[io.vdc_reg].B.l = io.VDC_ratch[io.vdc_reg];
		io.VDC[io.vdc_reg].B.h = V;
//		if (io.vdc_reg != CR)
//			TRACE("vdc_h: %02X,%02X\n", io.vdc_reg, V);
		if (io.vdc_reg>19) {
//			TRACE("ignore write hi vdc%d,%02x\n",io.vdc_reg,V);
		}
		return;
	}
	break;

  case 0x0400:	/* VCE */
	switch(A&7) {
	case 0: /*io.vce_reg.W = 0; io.vce_ratch=0;*/ /*??*/
//		TRACE("VCE 0, V=%X\n", V); return;
	case 2: io.vce_reg.B.l = V; return;
	case 3: io.vce_reg.B.h = V&1; return;
	case 4: io.VCE[io.vce_reg.W].B.l= V;
		{byte c; int i,n;
		n = io.vce_reg.W;
		c = io.VCE[n].W>>1;
		if (n==0) {
			for(i=0;i<256;i+=16) Pal[i]=c;
		}else if (n&15) Pal[n] = c;
		}
		return;
	case 5:
		/*io.VCE[io.vce_reg.W].B.l = io.vce_ratch;*/
//	DebugDumpFp(4, TRUE);
		io.VCE[io.vce_reg.W].B.h = V;
		{byte c; int i,n;
		n = io.vce_reg.W;
		c = io.VCE[n].W>>1;
		if (n==0) {
			for(i=0;i<256;i+=16) Pal[i]=c;
		}else if (n&15) Pal[n] = c;
		}
		io.vce_reg.W=(io.vce_reg.W+1)&0x1FF;
		return;
	//case 6: /* ?? */ return;
	case 1:	/*TRACE("VCE 1, V=%X\n", V);*/ return;
	case 6:	/*TRACE("VCE 6, V=%X\n", V);*/ return;
	case 7:	/*TRACE("VCE 7, V=%X\n", V);*/ return;
	}
	break;

  case 0x0800:	/* PSG */
	if (/*snd_bSound &&*/ io.psg_ch < 6)
	{
//		if (io.psg_ch==0)
//			TRACE("PSG %d,%02X\n", A&15, V);
		if ((A&15) <= 1)
		{
			int	i;
			for (i = 0; i < 6; i++)
				write_psg(i);
		}
		else
			write_psg(io.psg_ch);
	}
  	switch(A&15){
	case 0: io.psg_ch = V&7; return;
	case 1: io.psg_volume = V; return;
	case 2: io.PSG[io.psg_ch][2] = V; break;
	case 3: io.PSG[io.psg_ch][3] = V&15; break;
	case 4: io.PSG[io.psg_ch][4] = V; break;
	case 5: io.PSG[io.psg_ch][5] = V; break;
	case 6: if (io.PSG[io.psg_ch][4]&0x40){
				io.wave[io.psg_ch][0]=V&31;
			}else {
				io.wave[io.psg_ch][io.wavofs[io.psg_ch]]=V&31;
				io.wavofs[io.psg_ch]=(io.wavofs[io.psg_ch]+1)&31;
			} break;
	case 7: io.PSG[io.psg_ch][7] = V; break;
	case 8: io.psg_lfo_freq = V; break;
	case 9: io.psg_lfo_ctrl = V; break;
	/*default: TRACE("ignored PSG write\n");*/
    }
    return;

  case 0x0c00:	/* timer */
	//TRACE("Timer Access: A=%X,V=%X\n", A, V);
	switch(A&1){
	case 0: io.timer_reload = V&127; return;
	case 1: 
		V&=1;
		if (V && !io.timer_start)
			io.timer_counter = io.timer_reload;
		io.timer_start = V;
		return;
	}
	break;

  case 0x1000:	/* joypad */
//	  TRACE("V=%02X\n", V);
		watch_dog=0; // si escribe el pad no creo que se haya colgado..
		io.joy_select = V&1;
		if (V&2) io.joy_counter = 0;
		return;

  case 0x1400:	/* IRQ */
	switch(A&15){
	case 2: io.irq_mask = V;/*TRACE("irq_mask = %02X\n", V);*/ return;
	case 3: io.irq_status= (io.irq_status&~TIRQ)|(V&0xF8); return;
	}
	break;
#ifdef SUPPORT_FOR_ARCADE_CARD

 case 0x1A00:
      {

	if ((A & 0x1AF0) == 0x1AE0)
	  {
	    switch (A & 15)
	      {
	      case 0:
		io.ac_shift = (io.ac_shift & 0xffffff00) | V;
		break;
	      case 1:
		io.ac_shift = (io.ac_shift & 0xffff00ff) | (V << 8);
		break;
	      case 2:
		io.ac_shift = (io.ac_shift & 0xff00ffff) | (V << 16);
		break;
	      case 3:
		io.ac_shift = (io.ac_shift & 0x00ffffff) | (V << 24);
		break;
	      case 4:
		io.ac_shiftbits = V & 0x0f;
		if (io.ac_shiftbits != 0)
		  {
		    if (io.ac_shiftbits < 8)
		      {
			io.ac_shift <<= io.ac_shiftbits;
		      }
		    else
		      {
			io.ac_shift >>= (16 - io.ac_shiftbits);
		      }
		  }
	      default:
		break;
	      }
	    return;
	  }
	else
	  {
	    byte ac_port = (A >> 4) & 3;
	    switch (A & 15)
	      {
	      case 0:
	      case 1:

		if (io.ac_control[ac_port] & AC_USE_OFFSET)
		  {

		    ac_extra_mem[((io.ac_base[ac_port] +
				   io.ac_offset[ac_port]) & 0x1fffff)] = V;
		  }
		else
		  {

		    // Log("Write %d to 0x%04X (base)\n",V, io.ac_base[ac_port]);
		    ac_extra_mem[((io.ac_base[ac_port]) & 0x1fffff)] = V;
		  }

		if (io.ac_control[ac_port] & AC_ENABLE_INC)
		  {
		    if (io.ac_control[ac_port] & AC_INCREMENT_BASE)
		      io.ac_base[ac_port] =
			(io.ac_base[ac_port] +
			 io.ac_incr[ac_port]) & 0xffffff;
		    else
		      io.ac_offset[ac_port] =
			(io.ac_offset[ac_port] +
			 io.ac_incr[ac_port]) & 0xffffff;
		  }

		return;
	      case 2:
		io.ac_base[ac_port] = (io.ac_base[ac_port] & 0xffff00) | V;
		return;
	      case 3:
		io.ac_base[ac_port] =
		  (io.ac_base[ac_port] & 0xff00ff) | (V << 8);
		return;
	      case 4:
		io.ac_base[ac_port] =
		  (io.ac_base[ac_port] & 0x00ffff) | (V << 16);
		return;
	      case 5:
		io.ac_offset[ac_port] = (io.ac_offset[ac_port] & 0xff00) | V;
		return;
	      case 6:
		io.ac_offset[ac_port] =
		  (io.ac_offset[ac_port] & 0x00ff) | (V << 8);
		if (io.ac_control[ac_port] & (AC_ENABLE_OFFSET_BASE_6))
		  io.ac_base[ac_port] =
		    (io.ac_base[ac_port] + io.ac_offset[ac_port]) & 0xffffff;
		return;
	      case 7:
		io.ac_incr[ac_port] = (io.ac_incr[ac_port] & 0xff00) | V;
		return;
	      case 8:
		io.ac_incr[ac_port] =
		  (io.ac_incr[ac_port] & 0x00ff) | (V << 8);
		return;
	      case 9:
		io.ac_control[ac_port] = V;
		return;
	      case 0xa:
		if ((io.ac_control[ac_port]
                    & (AC_ENABLE_OFFSET_BASE_A | AC_ENABLE_OFFSET_BASE_6))
                    == (AC_ENABLE_OFFSET_BASE_A | AC_ENABLE_OFFSET_BASE_6))
		  io.ac_base[ac_port] =
		    (io.ac_base[ac_port] + io.ac_offset[ac_port]) & 0xffffff;
		return;
	   //   default:
		//Log ("\nUnknown AC write %d into 0x%04X\n", V, A);
	      }

	  }
      }
      break;
#endif
  case 0x1800:	/* CD-ROM extention */
	
	if(CD_emulation==0)
	  {
	
	  switch(A&15){
	  case 7: io.backup = ENABLE; return;
    	}
	  }
	  else pce_cd_handle_write_1800(A, V);
	  break;

  }
	//TRACE("ignore I/O write %04x,%02x\n",A,V);
//	DebugDumpTrace(4, TRUE);
}

int return_value_mask_tab_0002[32] =
  {
    0xFF,
    0xFF,
    0xFF,
    0xFF, /* unused */
    0xFF, /* unused */
    0xFF,
    0xFF,
    0xFF,
    0xFF, /* 8 */
    0xFF,
    0x1F, /* A */
    0x7F,
    0x1F, /* C */
    0xFF,
    0xFF, /* E */
    0x1F,
    0xFF, /* 10 */
    0xFF,
    /* No data for remaining reg, assuming 0xFF */
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF
  };

int return_value_mask_tab_0003[32] =
  {
    0xFF,
    0xFF,
    0xFF,
    0xFF, /* unused */
    0xFF, /* unused */
    0x1F,
    0x03,
    0x03,
    0x01, /* 8 */	/* ?? */
    0x00,
    0x7F, /* A */
    0x7F,
    0xFF, /* C */
    0x01,
    0x00, /* E */
    0x00,
    0xFF, /* 10 */
    0xFF,
    /* No data for remaining reg, assuming 0xFF */
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF
  };


int return_value_mask_tab_0400[8] =
  {
    0xFF,
    0x00,
    0xFF,
    0x01,
    0xFF,
    0x01,
    0xFF, /* unused */
    0xFF  /* unused */
  };

int return_value_mask_tab_0800[16] =
  {
    0x03,
    0xFF,
    0xFF,
    0x0F,
    0xDF,
    0xFF,
    0x1F,
    0x9F,
    0xFF,
    0x83,
    /* No data for remainig reg, assuming 0xFF */
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF,
    0xFF
  };

int return_value_mask_tab_0c00[2] =
  {
    0x7F,
    0x01
  };

int return_value_mask_tab_1400[4] =
  {
    0xFF,
    0xFF,
    0x03,
    0x03
  };


//! Returns the useful value mask depending on port value
static int
return_value_mask(UInt16 A)
{
  if (A < 0x400) // VDC
    {
      if ((A & 0x3) == 0x02)
        {
          return return_value_mask_tab_0002[io.vdc_reg];
        }
      else
        if ((A & 0x3) == 0x03)
          {
            return return_value_mask_tab_0003[io.vdc_reg];
          }
        else
          return 0xFF;
    }

  if (A < 0x800) // VCE
    return return_value_mask_tab_0400[A & 0x07];

  if (A < 0xC00) /* PSG */
    return return_value_mask_tab_0800[A & 0x0F];

  if (A < 0x1000) /* Timer */
    return return_value_mask_tab_0c00[A & 0x01];

  if (A < 0x1400) /* Joystick / IO port */
    return 0xFF;

  if (A < 0x1800) /* Interruption acknowledgement */
    return return_value_mask_tab_1400[A & 0x03];

  /* We don't know for higher ports */
  return 0xFF;
}

byte inline IO_read/*_raw*/(word A)
{
	byte ret;

	//printf("r%04x ",A&0x3FFF);
  switch(A&0x1FC0){
  case 0x0000: /* VDC */
  	switch(A&3){
	case 0:
		ret = io.vdc_status;
		io.vdc_status=0;//&=VDC_InVBlank;//&=~VDC_BSY;
		return ret;
	case 1:
		return 0;
	case 2:
		if (io.vdc_reg==VRR)
			return VRAM[io.VDC[MARR].W*2];
		else return io.VDC[io.vdc_reg].B.l;
	case 3:
		if (io.vdc_reg==VRR) {
			ret = VRAM[io.VDC[MARR].W*2+1];
			io.VDC[MARR].W+=io.vdc_inc;
//			TRACE0("VRAM read\n");
			return ret;
		} else return io.VDC[io.vdc_reg].B.h;
	}
	break;

  case 0x0400:/* VCE */
  	switch(A&7){
	case 4: return io.VCE[io.vce_reg.W].B.l;
	case 5: return io.VCE[io.vce_reg.W++].B.h;
	}
	break;

  case 0x0800:	/* PSG */
	switch(A&15){
	case 0: return io.psg_ch;
	case 1: return io.psg_volume;
	case 2: return io.PSG[io.psg_ch][2];
	case 3: return io.PSG[io.psg_ch][3];
	case 4: return io.PSG[io.psg_ch][4];
	case 5: return io.PSG[io.psg_ch][5];
	case 6:
		{
			int	ofs=io.wavofs[io.psg_ch];
			io.wavofs[io.psg_ch]=(io.wavofs[io.psg_ch]+1)&31;
			return io.wave[io.psg_ch][ofs];
		}
	case 7: return io.PSG[io.psg_ch][7];
	case 8: return io.psg_lfo_freq;
	case 9: return io.psg_lfo_ctrl;
	default: return NODATA;
	}
	break;

  case 0x0c00:	/* timer */
	return io.timer_counter;

  case 0x1000:	/* joypad */
	  watch_dog=0; // si lee el pad no creo que se haya colgado..
//	  TRACE("js=%d\n", io.joy_counter);
		ret = io.JOY[io.joy_counter]^0xff;
		if (io.joy_select&1) ret>>=4;
		else { ret&=15; io.joy_counter=(io.joy_counter+1)%5; }
		return ret|Country; /* country 0:JPN 1=US */

  case 0x1400:	/* IRQ */
	switch(A&15){
	case 2: return io.irq_mask;
	case 3: ret = io.irq_status;io.irq_status=0;return ret;
	}
	break;
case 0x18C0:		// Memory management ?
		switch (A & 15)
			{
				case 5:
				case 1:
					return 0xAA;
				case 2:
				case 6:
					return 0x55;
				case 3:
				case 7:
					return 0x03;
			}
		break;

#ifdef SUPPORT_FOR_ARCADE_CARD

case 0x1AC0:
		switch (A & 15)
		{
		case 0:
			return (byte) (io.ac_shift);
		case 1:
			return (byte) (io.ac_shift >> 8);
		case 2:
			return (byte) (io.ac_shift >> 16);
		case 3:
			return (byte) (io.ac_shift >> 24);
		case 4:
			return io.ac_shiftbits;
		case 5:
			return io.ac_unknown4;
		case 14:
			return (byte)(want_arcade_card_emulation ? 0x10 : NODATA);
		case 15:
			return (byte)(want_arcade_card_emulation ? 0x51 : NODATA);
//		default:
			//Log ("Unknown Arcade card port access : 0x%04X\n", A);
		}
		break;

	case 0x1A00:
	{
		byte ac_port = (byte)((A >> 4) & 3);
		switch (A & 15)
		{
		case 0:
		case 1:
			/*
			 * switch (io.ac_control[ac_port] & (AC_USE_OFFSET | AC_USE_BASE))
			 * {
			 * case 0:
			 * return ac_extra_mem[0];
			 * case AC_USE_OFFSET:
			 * ret = ac_extra_mem[io.ac_offset[ac_port]];
			 * if (!(io.ac_control[ac_port] & AC_INCREMENT_BASE))
			 * io.ac_offset[ac_port]+=io.ac_incr[ac_port];
			 * return ret;
			 * case AC_USE_BASE:
			 * ret = ac_extra_mem[io.ac_base[ac_port]];
			 * if (io.ac_control[ac_port] & AC_INCREMENT_BASE)
			 * io.ac_base[ac_port]+=io.ac_incr[ac_port];
			 * return ret;
			 * default:
			 * ret = ac_extra_mem[io.ac_base[ac_port] + io.ac_offset[ac_port]];
			 * if (io.ac_control[ac_port] & AC_INCREMENT_BASE)
			 * io.ac_base[ac_port]+=io.ac_incr[ac_port];
			 * else
			 * io.ac_offset[ac_port]+=io.ac_incr[ac_port];
			 * return ret;
			 * }
			 * return 0;
			 */


			if (io.ac_control[ac_port] & AC_USE_OFFSET)
				ret = ac_extra_mem[((io.ac_base[ac_port] +
						     io.
						     ac_offset[ac_port]) &
						    0x1fffff)];
			else
				ret = ac_extra_mem[((io.
						     ac_base[ac_port]) &
						    0x1fffff)];

			if (io.ac_control[ac_port] & AC_ENABLE_INC)
			{
				if (io.
				    ac_control[ac_port] & AC_INCREMENT_BASE)
					io.ac_base[ac_port] =
						(io.ac_base[ac_port] +
						 io.
						 ac_incr[ac_port]) & 0xffffff;
				else
					io.ac_offset[ac_port] = (UInt16)
						((io.ac_offset[ac_port] +
						 io.
						 ac_incr[ac_port]) & 0xffff);
			}


			return ret;
		


		case 2:
			return (byte) (io.ac_base[ac_port]);
		case 3:
			return (byte) (io.ac_base[ac_port] >> 8);
		case 4:
			return (byte) (io.ac_base[ac_port] >> 16);
		case 5:
			return (byte) (io.ac_offset[ac_port]);
		case 6:
			return (byte) (io.ac_offset[ac_port] >> 8);
		case 7:
			return (byte) (io.ac_incr[ac_port]);
		case 8:
			return (byte) (io.ac_incr[ac_port] >> 8);
		case 9:
			return io.ac_control[ac_port];
		//default:
			//Log ("Unknown Arcade card port access : 0x%04X\n", A);
		}
		break;
	}

#endif
  case 0x1800:	/* CD-ROM extention */
	if(CD_emulation==0)
	  {
	  switch(A&15){
	  case 3: return io.backup = DISABLE;
	  }
    	break;
	  } else 
	 return pce_cd_handle_read_1800(A);
  }
	//TRACE("ignore I/O read %04x\n",A);
//	DebugDumpFp(4, TRUE);
	return NODATA;
}
#if 0
byte IO_read (word A)
{
  int mask;
 byte temporary_return_value;

  if ((A < 0x800) || (A >= 0x1800)) // latch isn't affected out of the 0x800 - 0x1800 range
    return IO_read_raw(A);

  mask = return_value_mask(A);

  temporary_return_value = IO_read_raw(A);

  io.io_buffer = temporary_return_value | (io.io_buffer & ~mask);

  return io.io_buffer;
}

#endif
byte Loop6502(M6502 *R)
{
	static int UCount = 0;
	static int ACount = 0;
	static int prevline;
	int dispmin, dispmax;
	int ret;
	//printf("PC:%04x ",R->PC.W);

 

	dispmin = (MaxLine-MinLine>MAXDISP ? MinLine+((MaxLine-MinLine-MAXDISP+1)>>1) : MinLine);
	dispmax = (MaxLine-MinLine>MAXDISP ? MaxLine-((MaxLine-MinLine-MAXDISP+1)>>1) : MaxLine);

	scanline=(scanline+1)%scanlines_per_frame;
	//printf("scan %d\n",scanline);
	ret = INT_NONE;
	io.vdc_status&=~VDC_RasHit;
	if (scanline>MaxLine)
		io.vdc_status|=VDC_InVBlank;
//	if (scanline==MinLine+scanlines_per_frame-1)
//	else 
	if (scanline==MinLine) {
		io.vdc_status&=~VDC_InVBlank;
		prevline=dispmin;
		ScrollYDiff = 0;
		oldScrollYDiff = 0;
//		if (io.vdc_iswrite_h)
//		{
//			io.vdc_iswrite_h = 0;
//			ScrollY = io.VDC[BYR].W;
//		}
//		TRACE("\nFirstLine\n");
	}else
	if (scanline==MaxLine) {
		if (CheckSprites()) io.vdc_status|=VDC_SpHit;
		else io.vdc_status&=~VDC_SpHit;
		if (UCount) UCount--;
		else {
			if(!swap_screen)
			{
			if (SpriteON && SPONSwitch) RefreshSprite(prevline,dispmax,0);
			RefreshLine(prevline,dispmax-1);
			if (SpriteON && SPONSwitch) RefreshSprite(prevline,dispmax,1);
			}
			prevline=dispmax;
			UCount=UPeriod;
			RefreshScreen();
		}
	}
	if (scanline>=MinLine && scanline<=MaxLine) {
		if (scanline==(io.VDC[RCR].W&1023)-64) {
			if (RasHitON && !UCount && dispmin<=scanline && scanline<=dispmax) {
				if(!swap_screen)
				{
				if (SpriteON && SPONSwitch) RefreshSprite(prevline,scanline,0);
				RefreshLine(prevline,scanline-1);
				if (SpriteON && SPONSwitch) RefreshSprite(prevline,scanline,1);
				}
				prevline=scanline;
			}
			io.vdc_status|=VDC_RasHit;
			if (RasHitON) {
				//TRACE("rcr=%d\n", scanline);
				ret = INT_IRQ;
			}
		} else if (scroll) {
			if (scanline-1>prevline && !UCount) {
				int	tmpScrollX, tmpScrollY, tmpScrollYDiff;
				tmpScrollX=ScrollX;
				tmpScrollY=ScrollY;
				tmpScrollYDiff=ScrollYDiff;
				ScrollX=oldScrollX;
				ScrollY=oldScrollY;
				ScrollYDiff=oldScrollYDiff;
				if(!swap_screen)
				{
				if (SpriteON && SPONSwitch) RefreshSprite(prevline,scanline-1,0);
				RefreshLine(prevline,scanline-2);
				if (SpriteON && SPONSwitch) RefreshSprite(prevline,scanline-1,1);
				}
				prevline=scanline-1;
				ScrollX = tmpScrollX;
				ScrollY = tmpScrollY;
				ScrollYDiff = tmpScrollYDiff;
			}
		}
	} else {
		int rcr = (io.VDC[RCR].W&1023)-64;
		if (scanline==rcr)
		{
//			ScrollYDiff = scanline;
			if (RasHitON) {
				//TRACE("rcr=%d\n", scanline);
				io.vdc_status |= VDC_RasHit;
				ret = INT_IRQ;
			}
		}
	}
	scroll=0;
	if (scanline==MaxLine+1) {
//	if (scanline==scanlines_per_frame-63) {
		int J=JoyStick();
		if (J&0x10000) {return INT_QUIT;}
		io.JOY[0]=J;

		/* VRAM to SATB DMA */
		if (io.vdc_satb==1 || io.VDC[DCR].W&0x0010)
		{
			memcpy(SPRAM,VRAM+io.VDC[SATB].W*2,64*8);
			io.vdc_satb=1;
			io.vdc_status&=~VDC_SATBfinish;
		}
		if (ret==INT_IRQ)
			io.vdc_pendvsync = 1;
		else {
			//TRACE("vsync\n");
			//io.vdc_status|=VDC_InVBlank;
			if (VBlankON) {
				//TRACE("vsync=%d\n", scanline);
				ret = INT_IRQ;
			}
		}
	}
	else 
	if (scanline==min(MaxLine+5, scanlines_per_frame-1)) {
		if (io.vdc_satb) {
			io.vdc_status|=VDC_SATBfinish;
			io.vdc_satb = 0;
			if (SATBIntON) {
				//TRACE("SATB=%d\n", scanline);
				ret = INT_IRQ;
			}
/*		} else {
			io.vdc_status&=~VDC_SATBfinish;
			io.vdc_satb = 0;
*/		}
	} else if (io.vdc_pendvsync && ret!=INT_IRQ) {
		io.vdc_pendvsync = 0;
		//io.vdc_status|=VDC_InVBlank;
		if (VBlankON) {
			//TRACE("vsync=%d\n", scanline);
			ret = INT_IRQ;
		}
	}
	if (ret == INT_IRQ) {
		if (!(io.irq_mask&IRQ1)) {
			io.irq_status|=IRQ1;
			//if (io.vdc_status&0x20)
			//TRACE("status=%02X\n", io.vdc_status);
			//TRACE("irq:scan %d\n ",scanline);
			
			return ret;
		}
	}

	return INT_NONE;
}

byte TimerInt(M6502 *R)
{
/*if(FPS<24) TimerPeriod = (((BaseClock/1000)*3*1024))/21480;
else TimerPeriod = (((BaseClock/1000)*3*1024)*6/5)/21480;*/
TimerPeriod=(FPS<<10)/25;if(TimerPeriod<1024) TimerPeriod=1024;

	if (io.timer_start) {
		io.timer_counter--;
		if (io.timer_counter > 128) {
			io.timer_counter = io.timer_reload;
			//io.irq_status &= ~TIRQ;
			if (!(io.irq_mask&TIRQ)) {
				io.irq_status |= TIRQ;
				//TRACE("tirq=%d\n",scanline);
				//TRACE("tirq\n");

				return INT_TIMER;
			}
		}
	}
	return INT_NONE;
}

/*
	Hit Chesk Sprite#0 and others
*/
int CheckSprites(void)
{
	int i,x0,y0,w0,h0,x,y,w,h;
	SPR *spr;
	spr = (SPR*)SPRAM;
	x0 = spr->x;
	y0 = spr->y;
	w0 = (((spr->atr>>8 )&1)+1)*16;
	h0 = (((spr->atr>>12)&3)+1)*16;
	spr++;
	for(i=1;i<64;i++,spr++) {
		x = spr->x;
		y = spr->y;
		w = (((spr->atr>>8 )&1)+1)<<4;
		h = (((spr->atr>>12)&3)+1)<<4;
		if ((x<x0+w0)&&(x+w>x0)&&(y<y0+h0)&&(y+h>y0)) return TRUE;
	}
	return FALSE;
}
unsigned pre_tabl1[256];
static inline void plane2pixel(int no)
{
	volatile unsigned long M;
	byte *C=VRAM+(no<<5);
	unsigned long L,*C2 = VRAM2+no*8;
	int j;
	
	
    

	
  for(j=0;j<8;j++,C+=2,C2++) {
    /*M=C[0];
    L =((M&0x88)>>3)|((M&0x44)<<6)|((M&0x22)<<15)|((M&0x11)<<24);
	M=C[1];
	L|=((M&0x88)>>2)|((M&0x44)<<7)|((M&0x22)<<16)|((M&0x11)<<25);
	M=C[16];
	L|=((M&0x88)>>1)|((M&0x44)<<8)|((M&0x22)<<17)|((M&0x11)<<26);
	M=C[17];
	L|=((M&0x88))|((M&0x44)<<9)|((M&0x22)<<18)|((M&0x11)<<27);
	C2[0] = L; //37261504
	*/
	 M=C[0];
    L =pre_tabl1[M];
	M=C[1];
	L|=pre_tabl1[M]<<1;
	M=C[16];
	L|=pre_tabl1[M]<<2;
	M=C[17];
	L|=pre_tabl1[M]<<3;
	C2[0] = L; //37261504
  }
}

#if 0
static void sprite2pixel(void *dst,void *src,int h)
{
  int i;
  long *C2 = dst;
  byte *C = src;
  for(i=0;i<h*2;i++,C++,C2++){
	long L;
	byte M;
    M=C[0];
    L =((M&0x88)>>3)|((M&0x44)<<6)|((M&0x22)<<15)|((M&0x11)<<24);
    M=C[32];
    L|=((M&0x88)>>2)|((M&0x44)<<7)|((M&0x22)<<16)|((M&0x11)<<25);
    M=C[64];
    L|=((M&0x88)>>1)|((M&0x44)<<8)|((M&0x22)<<17)|((M&0x11)<<26);
    M=C[96];
    L|=((M&0x88))|((M&0x44)<<9)|((M&0x22)<<18)|((M&0x11)<<27);
	C2[0]=L;
/*
	M = C[0];
    L  =((M&0x8888)>>3)|((M&0x4444)<<14);
    LL =((M&0x2222)>>1)|((M&0x1111)<<16);
	M = C[16];
    L |=((M&0x8888)>>2)|((M&0x4444)<<15);
    LL|=((M&0x2222))|((M&0x1111)<<17);
	M = C[32];
    L |=((M&0x8888)>>1)|((M&0x4444)<<16);
    LL|=((M&0x2222)<<1)|((M&0x1111)<<18);
	M = C[64];
    L |=((M&0x8888))|((M&0x4444)<<17);
    LL|=((M&0x2222)<<2)|((M&0x1111)<<19);
	C2[0]=L;   //159D048C
	C2[1]=LL;  //37BF26AE
	C++;
	C2+=2;
*/
  }
}
#endif
/*
static long sp2pixel(byte *C)
{
	long L;
	byte M;
    M=C[0];
    L =((M&0x88)>>3)|((M&0x44)<<6)|((M&0x22)<<15)|((M&0x11)<<24);
    M=C[32];
    L|=((M&0x88)>>2)|((M&0x44)<<7)|((M&0x22)<<16)|((M&0x11)<<25);
    M=C[64];
    L|=((M&0x88)>>1)|((M&0x44)<<8)|((M&0x22)<<17)|((M&0x11)<<26);
    M=C[96];
    L|=((M&0x88))|((M&0x44)<<9)|((M&0x22)<<18)|((M&0x11)<<27);
	return L;
}
*/
static inline void sp2pixel(int no)
{
	volatile /*byte*/ unsigned  M;

	byte *C;
	unsigned long *C2;
	C=&VRAM[no<<7];
	C2=&VRAMS[no<<5];
	int i;
	
	for(i=0;i<32;i++,C++,C2++){
		volatile unsigned long L;
		/*M=C[0];
		L =((M&0x88)>>3)|((M&0x44)<<6)|((M&0x22)<<15)|((M&0x11)<<24);
		M=C[32];
		L|=((M&0x88)>>2)|((M&0x44)<<7)|((M&0x22)<<16)|((M&0x11)<<25);
		M=C[64];
		L|=((M&0x88)>>1)|((M&0x44)<<8)|((M&0x22)<<17)|((M&0x11)<<26);
		M=C[96];
		L|=((M&0x88))|((M&0x44)<<9)|((M&0x22)<<18)|((M&0x11)<<27);
		C2[0]=L;
		*/
		 M=C[0];
		L =pre_tabl1[M];
		M=C[32];
		L|=pre_tabl1[M]<<1;
		M=C[64];
		L|=pre_tabl1[M]<<2;
		M=C[96];
		L|=pre_tabl1[M]<<3;
		C2[0] = L;
	}
}

#define	PAL(c)	R[c]
//#define	SPal	(Pal+256)
extern byte *XBuf;
byte Black = 0;
#define	FC_W	io.screen_w
#define	FC_H	256

void RefreshLine(int Y1,int Y2)
{
	int X1,XW,Line;
	int x,y,h,offset,Shift;
	unsigned long L,L2;
	unsigned char *R1=&L;
	unsigned char *R2=&L2;
    int yincre;
	byte *PP;//,*ZP;
	unsigned char LPal[256];
	int n;

	for(n=0;n<256;n++)
	{
	LPal[n]=Pal[n];
	}
	//TRACE("%d-%d,Scroll=%d\n",Y1,Y2,ScrollY-ScrollYDiff);
	Y2++;
	PP=XBuf+/*WIDTH*(HEIGHT-FC_H)/2+*/(WIDTH-FC_W)/2+WIDTH*Y1;
//	if(!ScreenON || !BGONSwitch) memset(XBuf+Y1*WIDTH,Black,(Y2-Y1)*WIDTH);
//	else {
	if(ScreenON && BGONSwitch) {
		//TRACE("ScrollY=%d,diff=%d\n", ScrollY, ScrollYDiff);
		//TRACE("ScrollX=%d\n", ScrollX);
	y = Y1+ScrollY-ScrollYDiff;
	offset = y&7;
	h = 8-offset;
	if (h>Y2-Y1) h=Y2-Y1;
	y>>=3;
	PP-=ScrollX&7;
	XW=io.screen_w/8+1;
	Shift = ScrollX&7;
//	{byte *Z=ZBuf+Y1*ZW;
//	for(Line=Y1;Line<Y2;Line++,Z+=ZW) Z[0]=0;
//	}

  for(Line=Y1;Line<Y2;y++) {
//    ZP = ZBuf+Line*ZW;
	x = ScrollX/8;
	y &= io.bg_h-1;yincre=y*io.bg_w;
	for(X1=0;X1<XW;X1++,x++,PP+=8){
		volatile byte *R,*P,*C;//,*Z;
		volatile unsigned long *C2;
		int no,i;
		x&=io.bg_w-1;
		no = ((word*)VRAM)[x+yincre];
		R = &LPal[(no>>12)<<4];
		no&=0xFFF;
		if (vchange[no]) { vchange[no]=0; plane2pixel(no);}
		C2 = &VRAM2[(no<<3)+offset];
		C = &VRAM[(no<<5)+offset+offset];
		P = PP;
//		Z = ZP;
		for(i=0;i<h;i++,P+=WIDTH,C2++,C+=2/*,Z+=ZW*/) {
			
			BYTE	J;

			J = (C[0]|C[1]|C[16]|C[17]);
			if (!J) continue;

	/*		L=C2[0];
			if (J&0x80) P[0]=PAL((L>>4)&15);
			if (J&0x40) P[1]=PAL((L>>12)&15);
			if (J&0x20) P[2]=PAL((L>>20)&15);
			if (J&0x10) P[3]=PAL((L>>28));
			if (J&0x08) P[4]=PAL((L)&15);
			if (J&0x04) P[5]=PAL((L>>8)&15);
			if (J&0x02) P[6]=PAL((L>>16)&15);
			if (J&0x01) P[7]=PAL((L>>24)&15);
	*/
			L =L2= C2[0];
			L=(L>>4) & 0x0f0f0f0f;
			L2=L2 & 0x0f0f0f0f;
			if (J&0x80) P[0]=PAL(R1[0]);
			if (J&0x40) P[1]=PAL(R1[1]);
			if (J&0x20) P[2]=PAL(R1[2]);
			if (J&0x10) P[3]=PAL(R1[3]);
			if (J&0x08) P[4]=PAL(R2[0]);
			if (J&0x04) P[5]=PAL(R2[1]);
			if (J&0x02) P[6]=PAL(R2[2]);
			if (J&0x01) P[7]=PAL(R2[3]);
//			L = J<<Shift;
//			Z[0]|=L>>8;Z[1]=L;
		}
	}
	Line+=h;
	PP+=WIDTH*h-(XW<<3);
	offset = 0;
	h = Y2-Line;
	if (h>8) h=8;
  }
  	}
	/* Refresh Sprite */
//	if (SpriteON) RefreshSprite(Y1,Y2);
}

#define	V_FLIP	0x8000
#define	H_FLIP	0x0800
#define	SPBG	0x80
#define	CGX		0x100

static void inline PutSprite(byte *P,byte *C,unsigned long *C2,byte *R,int h,int inc)
{
	int i,J;
	unsigned long L,L2;
	unsigned char *R1=&L;
	unsigned char *R2=&L2;

	for(i=0;i<h;i++,C+=inc,C2+=inc,P+=WIDTH) {
		J = ((word*)C)[0]|((word*)C)[16]|((word*)C)[32]|((word*)C)[48];
		if (!J) continue;
	/*
		L = C2[1];//sp2pixel(C+1);
		if (J&0x8000) P[0]=PAL((L>>4)&15);
		if (J&0x4000) P[1]=PAL((L>>12)&15);
		if (J&0x2000) P[2]=PAL((L>>20)&15);
		if (J&0x1000) P[3]=PAL((L>>28));
		if (J&0x0800) P[4]=PAL((L)&15);
		if (J&0x0400) P[5]=PAL((L>>8)&15);
		if (J&0x0200) P[6]=PAL((L>>16)&15);
		if (J&0x0100) P[7]=PAL((L>>24)&15);
		L = C2[0];//sp2pixel(C);
		if (J&0x80) P[8 ]=PAL((L>>4)&15);
		if (J&0x40) P[9 ]=PAL((L>>12)&15);
		if (J&0x20) P[10]=PAL((L>>20)&15);
		if (J&0x10) P[11]=PAL((L>>28));
		if (J&0x08) P[12]=PAL((L)&15);
		if (J&0x04) P[13]=PAL((L>>8)&15);
		if (J&0x02) P[14]=PAL((L>>16)&15);
		if (J&0x01) P[15]=PAL((L>>24)&15);
		*/
		L =L2= C2[1];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;

		if (J&0x8000) P[0]=PAL(R1[0]);
		if (J&0x4000) P[1]=PAL(R1[1]);
		if (J&0x2000) P[2]=PAL(R1[2]);
		if (J&0x1000) P[3]=PAL(R1[3]);
		if (J&0x0800) P[4]=PAL(R2[0]);
		if (J&0x0400) P[5]=PAL(R2[1]);
		if (J&0x0200) P[6]=PAL(R2[2]);
		if (J&0x0100) P[7]=PAL(R2[3]);
		L =L2= C2[0];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if (J&0x80) P[8 ]=PAL(R1[0]);
		if (J&0x40) P[9 ]=PAL(R1[1]);
		if (J&0x20) P[10]=PAL(R1[2]);
		if (J&0x10) P[11]=PAL(R1[3]);
		if (J&0x08) P[12]=PAL(R2[0]);
		if (J&0x04) P[13]=PAL(R2[1]);
		if (J&0x02) P[14]=PAL(R2[2]);
		if (J&0x01) P[15]=PAL(R2[3]);
	}
}

static void inline PutSpriteHflip(byte *P,byte *C,unsigned long *C2,byte *R,int h,int inc)
{
	int i,J;
	unsigned long L,L2;
	unsigned char *R1=&L;
	unsigned char *R2=&L2;
	for(i=0;i<h;i++,C+=inc,C2+=inc,P+=WIDTH) {
		J = ((word*)C)[0]|((word*)C)[16]|((word*)C)[32]|((word*)C)[48];
		if (!J) continue;
		/*L = C2[1];//sp2pixel(C+1);
		if (J&0x8000) P[15]=PAL((L>>4)&15);
		if (J&0x4000) P[14]=PAL((L>>12)&15);
		if (J&0x2000) P[13]=PAL((L>>20)&15);
		if (J&0x1000) P[12]=PAL((L>>28));
		if (J&0x0800) P[11]=PAL((L)&15);
		if (J&0x0400) P[10]=PAL((L>>8)&15);
		if (J&0x0200) P[9]=PAL((L>>16)&15);
		if (J&0x0100) P[8]=PAL((L>>24)&15);
		L = C2[0];//sp2pixel(C);
		if (J&0x80) P[7]=PAL((L>>4)&15);
		if (J&0x40) P[6]=PAL((L>>12)&15);
		if (J&0x20) P[5]=PAL((L>>20)&15);
		if (J&0x10) P[4]=PAL((L>>28));
		if (J&0x08) P[3]=PAL((L)&15);
		if (J&0x04) P[2]=PAL((L>>8)&15);
		if (J&0x02) P[1]=PAL((L>>16)&15);
		if (J&0x01) P[0]=PAL((L>>24)&15);*/
		L =L2= C2[1];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;

		if (J&0x8000) P[15]=PAL(R1[0]);
		if (J&0x4000) P[14]=PAL(R1[1]);
		if (J&0x2000) P[13]=PAL(R1[2]);
		if (J&0x1000) P[12]=PAL(R1[3]);
		if (J&0x0800) P[11]=PAL(R2[0]);
		if (J&0x0400) P[10]=PAL(R2[1]);
		if (J&0x0200) P[9]=PAL(R2[2]);
		if (J&0x0100) P[8]=PAL(R2[3]);
		L =L2= C2[0];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if (J&0x80) P[7 ]=PAL(R1[0]);
		if (J&0x40) P[6 ]=PAL(R1[1]);
		if (J&0x20) P[5]=PAL(R1[2]);
		if (J&0x10) P[4]=PAL(R1[3]);
		if (J&0x08) P[3]=PAL(R2[0]);
		if (J&0x04) P[2]=PAL(R2[1]);
		if (J&0x02) P[1]=PAL(R2[2]);
		if (J&0x01) P[0]=PAL(R2[3]);
	}
}

static void inline PutSpriteM(byte *P,byte *C,unsigned long *C2,byte *R,int h,int inc,byte *M,byte pr)
{
	int i,J;
	unsigned long L,L2;
	unsigned char *R1=&L;
	unsigned char *R2=&L2;
	for(i=0;i<h;i++,C+=inc,C2+=inc,P+=WIDTH,M+=WIDTH) {
		J = ((word*)C)[0]|((word*)C)[16]|((word*)C)[32]|((word*)C)[48];
		if (!J) continue;
		/*
		L = C2[1];//sp2pixel(C+1);
		if ((J&0x8000)&&M[0]<=pr) P[0]=PAL((L>>4)&15);
		if ((J&0x4000)&&M[1]<=pr) P[1]=PAL((L>>12)&15);
		if ((J&0x2000)&&M[2]<=pr) P[2]=PAL((L>>20)&15);
		if ((J&0x1000)&&M[3]<=pr) P[3]=PAL((L>>28));
		if ((J&0x0800)&&M[4]<=pr) P[4]=PAL((L)&15);
		if ((J&0x0400)&&M[5]<=pr) P[5]=PAL((L>>8)&15);
		if ((J&0x0200)&&M[6]<=pr) P[6]=PAL((L>>16)&15);
		if ((J&0x0100)&&M[7]<=pr) P[7]=PAL((L>>24)&15);
		L = C2[0];//sp2pixel(C);
		if ((J&0x80)&&M[8 ]<=pr) P[8 ]=PAL((L>>4)&15);
		if ((J&0x40)&&M[9 ]<=pr) P[9 ]=PAL((L>>12)&15);
		if ((J&0x20)&&M[10]<=pr) P[10]=PAL((L>>20)&15);
		if ((J&0x10)&&M[11]<=pr) P[11]=PAL((L>>28));
		if ((J&0x08)&&M[12]<=pr) P[12]=PAL((L)&15);
		if ((J&0x04)&&M[13]<=pr) P[13]=PAL((L>>8)&15);
		if ((J&0x02)&&M[14]<=pr) P[14]=PAL((L>>16)&15);
		if ((J&0x01)&&M[15]<=pr) P[15]=PAL((L>>24)&15);
		*/
		L =L2= C2[1];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if ((J&0x8000)&&M[0]<=pr) P[0]=PAL(R1[0]);
		if ((J&0x4000)&&M[1]<=pr) P[1]=PAL(R1[1]);
		if ((J&0x2000)&&M[2]<=pr) P[2]=PAL(R1[2]);
		if ((J&0x1000)&&M[3]<=pr) P[3]=PAL(R1[3]);
		if ((J&0x0800)&&M[4]<=pr) P[4]=PAL(R2[0]);
		if ((J&0x0400)&&M[5]<=pr) P[5]=PAL(R2[1]);
		if ((J&0x0200)&&M[6]<=pr) P[6]=PAL(R2[2]);
		if ((J&0x0100)&&M[7]<=pr) P[7]=PAL(R2[3]);
		L =L2= C2[0];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if ((J&0x80)&&M[8 ]<=pr) P[8 ]=PAL(R1[0]);
		if ((J&0x40)&&M[9 ]<=pr) P[9 ]=PAL(R1[1]);
		if ((J&0x20)&&M[10]<=pr) P[10]=PAL(R1[2]);
		if ((J&0x10)&&M[11]<=pr) P[11]=PAL(R1[3]);
		if ((J&0x08)&&M[12]<=pr) P[12]=PAL(R2[0]);
		if ((J&0x04)&&M[13]<=pr) P[13]=PAL(R2[1]);
		if ((J&0x02)&&M[14]<=pr) P[14]=PAL(R2[2]);
		if ((J&0x01)&&M[15]<=pr) P[15]=PAL(R2[3]);
	}
}

static void inline PutSpriteHflipM(byte *P,byte *C,unsigned long *C2,byte *R,int h,int inc,byte *M,byte pr)
{
	int i,J;
	unsigned long L,L2;
	unsigned char *R1=&L;
	unsigned char *R2=&L2;
	for(i=0;i<h;i++,C+=inc,C2+=inc,P+=WIDTH,M+=WIDTH) {
		J = ((word*)C)[0]|((word*)C)[16]|((word*)C)[32]|((word*)C)[48];
		if (!J) continue;
		
		/*L = C2[1];//sp2pixel(C+1);
		if ((J&0x8000)&&M[15]<=pr) P[15]=PAL((L>>4)&15);
		if ((J&0x4000)&&M[14]<=pr) P[14]=PAL((L>>12)&15);
		if ((J&0x2000)&&M[13]<=pr) P[13]=PAL((L>>20)&15);
		if ((J&0x1000)&&M[12]<=pr) P[12]=PAL((L>>28));
		if ((J&0x0800)&&M[11]<=pr) P[11]=PAL((L)&15);
		if ((J&0x0400)&&M[10]<=pr) P[10]=PAL((L>>8)&15);
		if ((J&0x0200)&&M[9]<=pr) P[9]=PAL((L>>16)&15);
		if ((J&0x0100)&&M[8]<=pr) P[8]=PAL((L>>24)&15);
		L = C2[0];//sp2pixel(C);
		if ((J&0x80)&&M[7]<=pr) P[7]=PAL((L>>4)&15);
		if ((J&0x40)&&M[6]<=pr) P[6]=PAL((L>>12)&15);
		if ((J&0x20)&&M[5]<=pr) P[5]=PAL((L>>20)&15);
		if ((J&0x10)&&M[4]<=pr) P[4]=PAL((L>>28));
		if ((J&0x08)&&M[3]<=pr) P[3]=PAL((L)&15);
		if ((J&0x04)&&M[2]<=pr) P[2]=PAL((L>>8)&15);
		if ((J&0x02)&&M[1]<=pr) P[1]=PAL((L>>16)&15);
		if ((J&0x01)&&M[0]<=pr) P[0]=PAL((L>>24)&15);
		*/
		L =L2= C2[1];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if ((J&0x8000)&&M[15]<=pr) P[15]=PAL(R1[0]);
		if ((J&0x4000)&&M[14]<=pr) P[14]=PAL(R1[1]);
		if ((J&0x2000)&&M[13]<=pr) P[13]=PAL(R1[2]);
		if ((J&0x1000)&&M[12]<=pr) P[12]=PAL(R1[3]);
		if ((J&0x0800)&&M[11]<=pr) P[11]=PAL(R2[0]);
		if ((J&0x0400)&&M[10]<=pr) P[10]=PAL(R2[1]);
		if ((J&0x0200)&&M[9 ]<=pr) P[9 ]=PAL(R2[2]);
		if ((J&0x0100)&&M[8 ]<=pr) P[8]=PAL(R2[3]);
		L =L2= C2[0];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if ((J&0x80)&&M[7]<=pr) P[7]=PAL(R1[0]);
		if ((J&0x40)&&M[6]<=pr) P[6]=PAL(R1[1]);
		if ((J&0x20)&&M[5]<=pr) P[5]=PAL(R1[2]);
		if ((J&0x10)&&M[4]<=pr) P[4]=PAL(R1[3]);
		if ((J&0x08)&&M[3]<=pr) P[3]=PAL(R2[0]);
		if ((J&0x04)&&M[2]<=pr) P[2]=PAL(R2[1]);
		if ((J&0x02)&&M[1]<=pr) P[1]=PAL(R2[2]);
		if ((J&0x01)&&M[0]<=pr) P[0]=PAL(R2[3]);

	}
}

static void inline PutSpriteMakeMask(byte *P,byte *C,unsigned long *C2,byte *R,int h,int inc,byte *M,byte pr)
{
	int i,J;
	unsigned long L,L2;
	unsigned char *R1=&L;
	unsigned char *R2=&L2;

	for(i=0;i<h;i++,C+=inc,C2+=inc,P+=WIDTH,M+=WIDTH) {
		J = ((word*)C)[0]|((word*)C)[16]|((word*)C)[32]|((word*)C)[48];
		if (!J) continue;
		L =L2= C2[1];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if (J&0x8000) {P[0]=PAL(R1[0]); M[0]=pr;}
		if (J&0x4000) {P[1]=PAL(R1[1]); M[1]=pr;}
		if (J&0x2000) {P[2]=PAL(R1[2]); M[2]=pr;}
		if (J&0x1000) {P[3]=PAL(R1[3]); M[3]=pr;}
		if (J&0x0800) {P[4]=PAL(R2[0]); M[4]=pr;}
		if (J&0x0400) {P[5]=PAL(R2[1]); M[5]=pr;}
		if (J&0x0200) {P[6]=PAL(R2[2]); M[6]=pr;}
		if (J&0x0100) {P[7]=PAL(R2[3]); M[7]=pr;}
		
		L =L2= C2[0];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if (J&0x80) {P[8 ]=PAL(R1[0]); M[8]=pr;}
		if (J&0x40) {P[9 ]=PAL(R1[1]); M[9]=pr;}
		if (J&0x20) {P[10]=PAL(R1[2]); M[10]=pr;}
		if (J&0x10) {P[11]=PAL(R1[3]); M[11]=pr;}
		if (J&0x08) {P[12]=PAL(R2[0]); M[12]=pr;}
		if (J&0x04) {P[13]=PAL(R2[1]); M[13]=pr;}
		if (J&0x02) {P[14]=PAL(R2[2]); M[14]=pr;}
		if (J&0x01) {P[15]=PAL(R2[3]); M[15]=pr;}
	}
}

static void inline  PutSpriteHflipMakeMask(byte *P,byte *C,unsigned long *C2,byte *R,int h,int inc,byte *M,byte pr)
{
	int i,J;
	unsigned long L,L2;
	unsigned char *R1=&L;
	unsigned char *R2=&L2;

	for(i=0;i<h;i++,C+=inc,C2+=inc,P+=WIDTH,M+=WIDTH) {
		J = ((word*)C)[0]|((word*)C)[16]|((word*)C)[32]|((word*)C)[48];
		if (!J) continue;
		/*L = C2[1];//sp2pixel(C+1);
		if (J&0x8000) {P[15]=PAL((L>>4)&15);  M[15]=pr;}
		if (J&0x4000) {P[14]=PAL((L>>12)&15); M[14]=pr;}
		if (J&0x2000) {P[13]=PAL((L>>20)&15); M[13]=pr;}
		if (J&0x1000) {P[12]=PAL((L>>28));    M[12]=pr;}
		if (J&0x0800) {P[11]=PAL((L)&15);     M[11]=pr;}
		if (J&0x0400) {P[10]=PAL((L>>8)&15);  M[10]=pr;}
		if (J&0x0200) {P[9]=PAL((L>>16)&15);  M[9]=pr;}
		if (J&0x0100) {P[8]=PAL((L>>24)&15);  M[8]=pr;}
		L = C2[0];//sp2pixel(C);
		if (J&0x80) {P[7]=PAL((L>>4)&15);  M[7]=pr;}
		if (J&0x40) {P[6]=PAL((L>>12)&15); M[6]=pr;}
		if (J&0x20) {P[5]=PAL((L>>20)&15); M[5]=pr;}
		if (J&0x10) {P[4]=PAL((L>>28));    M[4]=pr;}
		if (J&0x08) {P[3]=PAL((L)&15);     M[3]=pr;}
		if (J&0x04) {P[2]=PAL((L>>8)&15);  M[2]=pr;}
		if (J&0x02) {P[1]=PAL((L>>16)&15); M[1]=pr;}
		if (J&0x01) {P[0]=PAL((L>>24)&15); M[0]=pr;}
		*/
		L =L2= C2[1];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if (J&0x8000) {P[15]=PAL(R1[0]); M[15]=pr;}
		if (J&0x4000) {P[14]=PAL(R1[1]); M[14]=pr;}
		if (J&0x2000) {P[13]=PAL(R1[2]); M[13]=pr;}
		if (J&0x1000) {P[12]=PAL(R1[3]); M[12]=pr;}
		if (J&0x0800) {P[11]=PAL(R2[0]); M[11]=pr;}
		if (J&0x0400) {P[10]=PAL(R2[1]); M[10]=pr;}
		if (J&0x0200) {P[9 ]=PAL(R2[2]); M[9 ]=pr;}
		if (J&0x0100) {P[8 ]=PAL(R2[3]); M[8 ]=pr;}
		
		L =L2= C2[0];
		L=(L>>4) & 0x0f0f0f0f;
		L2=L2 & 0x0f0f0f0f;
		if (J&0x80) {P[7]=PAL(R1[0]); M[7]=pr;}
		if (J&0x40) {P[6]=PAL(R1[1]); M[6]=pr;}
		if (J&0x20) {P[5]=PAL(R1[2]); M[5]=pr;}
		if (J&0x10) {P[4]=PAL(R1[3]); M[4]=pr;}
		if (J&0x08) {P[3]=PAL(R2[0]); M[3]=pr;}
		if (J&0x04) {P[2]=PAL(R2[1]); M[2]=pr;}
		if (J&0x02) {P[1]=PAL(R2[2]); M[1]=pr;}
		if (J&0x01) {P[0]=PAL(R2[3]); M[0]=pr;}
	}
}

void RefreshSprite(int Y1,int Y2,BYTE bg)
{
	int n;
	SPR *spr;
	unsigned char SPal[256];

	static int usespbg = 0;
	int desplazx;

	spr = (SPR*)SPRAM + 63;
    desplazx=(WIDTH-FC_W)>>1;
	if (bg==0)
		usespbg=0;
    for(n=0;n<256;n++)
	{
	SPal[n]=Pal[n+256];
	}
	for(n=0;n<64;n++,spr--){
		int x,y,no,atr,inc,cgx,cgy;
		volatile byte *R,*C;
		volatile unsigned long *C2;
		int	pos;
		int h,t,i,j;
		int y_sum;
		int spbg;

		atr=spr->atr;
		spbg = (atr>>7)&1;
		if (spbg != bg)
			continue;
		y = (spr->y&1023)-64;
		x = (spr->x&1023)-32;
		no= spr->no&2047;
		cgx = (atr>>8)&1;
		cgy = (atr>>12)&3;
		cgy |= cgy>>1;
		no = (no>>1)&~((cgy<<1)+cgx);
		if (y>=Y2 || y+((cgy+1)<<4)<Y1 || x>=FC_W || x+((cgx+1)<<4)<0) continue;

		R = &SPal[(atr&15)<<4];
		for (i=0;i<cgy*2+cgx+1;i++) {
			if (vchanges[no+i]) {
				vchanges[no+i] = 0;
				sp2pixel(no+i);
			}
			if (!cgx) i++;
		}
		C = &VRAM[no<<7];
		C2 = &VRAMS[no<<5];
		pos = desplazx+/*WIDTH*(HEIGHT-FC_H)/2+(WIDTH-FC_W)/2+*/WIDTH*y+x;
		inc = 2;
		if (atr&V_FLIP) { inc=-2; C+=30+(cgy<<8); C2+=30+(cgy<<6);}
		y_sum = 0;
		//printf("(%d,%d,%d,%d,%d)",x,y,cgx,cgy,h);
		//TRACE("Spr#%d,no=%d,x=%d,y=%d,CGX=%d,CGY=%d,xb=%d,yb=%d\n", n, no, x, y, cgx, cgy, atr&H_FLIP, atr&V_FLIP);
		for(i=0;i<=cgy;i++) {
			t = Y1-y-y_sum;
			h = 16;
			if (t>0) {
				C+=t*inc;
				C2+=t*inc;
				h-=t;
				pos+=t*WIDTH;
			}
			if (h>Y2-y-y_sum) h = Y2-y-y_sum;

if(!fast_sprite)
		{
			if (spbg==0){
				usespbg=1;
				if (atr&H_FLIP){
				  for(j=0;j<=cgx;j++)
					PutSpriteHflipMakeMask(XBuf+pos+((cgx-j)<<4),C+(j<<7),C2+(j<<5),R,h,inc,SPM+pos+((cgx-j)<<4),n);
				}else{
				  for(j=0;j<=cgx;j++)
					PutSpriteMakeMask(XBuf+pos+(j<<4),C+(j<<7),C2+(j<<5),R,h,inc,SPM+pos+(j<<4),n);
				}
			} else if (usespbg) {
				if (atr&H_FLIP){
				  for(j=0;j<=cgx;j++)
					PutSpriteHflipM(XBuf+pos+((cgx-j)<<4),C+(j<<7),C2+(j<<5),R,h,inc,SPM+pos+((cgx-j)<<4),n);
				}else{
				  for(j=0;j<=cgx;j++)
					PutSpriteM(XBuf+pos+(j<<4),C+(j<<7),C2+(j<<5),R,h,inc,SPM+pos+(j<<4),n);
				}
			} else {
				if (atr&H_FLIP){
				  for(j=0;j<=cgx;j++)
					PutSpriteHflip(XBuf+pos+((cgx-j)<<4),C+(j<<7),C2+(j<<5),R,h,inc);
				}else{
				  for(j=0;j<=cgx;j++)
					PutSprite(XBuf+pos+(j<<4),C+(j<<7),C2+(j<<5),R,h,inc);
				}
			}
		}
			else // fast_sprite
			{
			if (atr&H_FLIP){
				  for(j=0;j<=cgx;j++)
					PutSpriteHflip(XBuf+pos+((cgx-j)<<4),C+(j<<7),C2+(j<<5),R,h,inc);
				}else{
				  for(j=0;j<=cgx;j++)
					PutSprite(XBuf+pos+(j<<4),C+(j<<7),C2+(j<<5),R,h,inc);
				}
			}
		

			
			pos+=h*WIDTH;
			C+=(h+16*7)*inc;
			C2+=(h+16)*inc;
			y_sum+=16;
		}
	}
}

void RefreshScreen(void)
{
	int dispmin,dispmax;
     volatile unsigned *p,v;
	 int n;
	dispmin = (MaxLine-MinLine>MAXDISP ? MinLine+((MaxLine-MinLine-MAXDISP+1)>>1) : MinLine);
	dispmax = (MaxLine-MinLine>MAXDISP ? MaxLine-((MaxLine-MinLine-MAXDISP+1)>>1) : MaxLine);
	PutImage((WIDTH-FC_W)>>1,/*(HEIGHT-FC_H)/2+*/MinLine+dispmin,FC_W,dispmax-dispmin+1);
	// ATENCION: Paso X en PutImage unicamente para conocer si debo invertir la pantalla
	
//	memset(XBuf+MinLine*WIDTH,Pal[0],(MaxLine-MinLine)*WIDTH);

	v=Pal[0]; v=(v<<8) | v; v=(v<<8) | v; v=(v<<8) | v;
	p=(unsigned *) XBuf+MinLine*WIDTH; n=((MaxLine-MinLine)*WIDTH)>>2;	while(n) {*p++=v;n--;}
//	memset(SPM+MinLine*WIDTH,0,(MaxLine-MinLine)*WIDTH);
	p=(unsigned *) SPM+MinLine*WIDTH; n=((MaxLine-MinLine)*WIDTH)>>2;	while(n) {*p++=0;n--;}
	
}
static int is_a_sav=0;
int CartLoad(char *name)
{
	FILE *fp;
	int fsize;
	int use_gzip=0;
	
  //  if(iso_FILE) {fclose(iso_FILE);iso_FILE=0;}
	//open_wav("/mnt/sd/roms/pcengine/track-04.wav");
	is_a_sav=0;
	CD_emulation=0;
	actual_track=0;
	CD_track[0].filename[0]=0;
	MY_filename=name;   
    if (is_ext (name, ".sav"))
	{
	if(!load_game(1)) return -1; // error cargando save game
	name=MY_filename; // reemplazo de nombre
	is_a_sav=1;
	}

	ISO_filename=0;
	if (is_ext (name, ".iso") || is_ext (name, ".ISO") || is_ext (name, ".toc") || is_ext (name, ".TOC"))
    {
    ISO_filename=name;
	
	CD_emulation = 2;
	if(!is_ext (name, ".toc") && !is_ext (name, ".TOC"))
	{
	 if (!(iso_FILE = fopen (ISO_filename, "rb")))
	{
	 CD_emulation = 0;
	  return -1;
	}

      fill_cd_info ();
	  //fclose(iso_FILE);iso_FILE=0;
	  // CD_emulation = 3;
	}
	else
		{
		 //fill_cd_info ();
	  if(ReadTocList(name)<0) {CD_emulation = 0;return -1;}

	  iso_FILE=0;
	  CD_emulation = 3;
		}
	fp=NULL;
    if(CD_track[0].filename[0]!=0)
		{
		fp=fopen(CD_track[0].filename,"rb");
		if (fp && is_ext (CD_track[0].filename, ".bz2") || is_ext (CD_track[0].filename, ".BZ2")) use_gzip=1;
		}
	if (fp==NULL)fp=fopen("/mnt/sd/roms/pcengine/syscard.pce","rb");
	if (fp==NULL) fp=fopen("/mnt/sd/roms/pcengine/SYSCARD.PCE","rb");
	if (fp==NULL) {fp=fopen("/mnt/sd/roms/pcengine/syscard.pce.bz2","rb");if(fp) use_gzip=1;}
	if (fp==NULL) {fp=fopen("/mnt/sd/roms/pcengine/SYSCARD.PCE.bz2","rb");if(fp) use_gzip=1;}
	if (fp==NULL) {
	//	TRACE("%s not found.\n",name);
	if(iso_FILE) {fclose(iso_FILE);iso_FILE=0;}
	CD_emulation = 0;
		return -1;
	}
	if(use_gzip)
	{
	BZFILE * my_bzip;
	int bzip_err=0;
	int n,m;
	fsize=0;
	
	if (fp==NULL) {	return -1;	}
	ROM =(BYTE *)malloc(2*1024*1024);
	if(ROM==NULL) {fclose(fp);return -2;}
	my_bzip=BZ2_bzReadOpen( &bzip_err, fp, 0, 1, NULL, 0 );
	
	fsize=BZ2_bzRead (&bzip_err, my_bzip, ROM, 2*1024*1024);
	
	BZ2_bzReadClose (&bzip_err, my_bzip);
    fclose(fp);
	for(n=0;n<(fsize & ~0x1fff); n++)
		{
		ROM[n]=ROM[n+(fsize&0x1fff)];
		}
	fsize&=~0x1fff;
	ROM_size = fsize/0x2000;
	}
	else
	{
	fseek(fp,0,SEEK_END);
	fsize = ftell(fp);
	
	fseek(fp,fsize&0x1fff,SEEK_SET);
	//printf("seekptr %x",ftell(fp));
	fsize&=~0x1fff;
	
//	ROM = (BYTE *) malloc(48*0x2000 + 512 ); 
	ROM =(BYTE *)malloc(fsize+0x2000);

	if(ROM==NULL) {CD_emulation = 0;fclose(fp);return -2;}
	ROM_size = fsize/0x2000;
	fread(ROM,1,fsize,fp);
	fclose(fp);
	}
	
  
	}
	else
	{
    if (is_ext (name, ".bz2") || is_ext (name, ".BZ2"))
	{
	BZFILE * my_bzip;
	int bzip_err=0;
	int n,m;
	fsize=0;
	fp=fopen(name,"rb");
	if (fp==NULL) {	return -1;	}
	ROM =(BYTE *)malloc(2*1024*1024);
	if(ROM==NULL) {fclose(fp);return -2;}
	my_bzip=BZ2_bzReadOpen( &bzip_err, fp, 0, 1, NULL, 0 );
	
	fsize=BZ2_bzRead (&bzip_err, my_bzip, ROM, 2*1024*1024);
	
	BZ2_bzReadClose (&bzip_err, my_bzip);
    fclose(fp);
	for(n=0;n<(fsize & ~0x1fff); n++)
		{
		ROM[n]=ROM[n+(fsize&0x1fff)];
		}
	fsize&=~0x1fff;
	ROM_size = fsize/0x2000;
	}
	else
		{
		fp=fopen(name,"rb");
		if (fp==NULL) {	return -1;	}
		fseek(fp,0,SEEK_END);
		fsize = ftell(fp);
	
		fseek(fp,fsize&0x1fff,SEEK_SET);
		fsize&=~0x1fff;
		ROM =(BYTE *)malloc(fsize+0x2000);
		if(ROM==NULL) {fclose(fp);return -2;}
		ROM_size = fsize/0x2000;
		fread(ROM,1,fsize,fp);
		fclose(fp);
		}
	}
	//printf("ROM size:%x\n",fsize);
	

	if (strstr(name, "populous") || strstr(name, "POPULOUS"))
	{
	
		populus = 1;
	}
	else
		populus = 0;
	return 0;
}

typedef struct
{
unsigned ID;
int have;
int page[8];
int CD_cmd[8];
int reserved[256];
} t_cab_sav;

extern int CD_track_cmd[8];

static FILE *fp_bzip=0;

int compress_rom(char *name)
{

int i,n,m;
char filename[256];
BZFILE * my_bzip;
int bzip_err=0;
char *temp;
FILE *fp, *fp_bzip;
strcpy(filename,name);

temp=malloc(1024*2048);
if(!temp) return -3;

strcat(filename,".bz2");

fp = fopen(name, "rb");
if (fp == NULL) {free(temp);return -1;}

fp_bzip = fopen(filename, "wb");
if (fp_bzip == NULL) {free(temp);fclose(fp);return -2;}
	
fseek(fp,0,SEEK_END);
m = ftell(fp);
fseek(fp,0,SEEK_SET);
if(m>(1024*2048)) {free(temp);fclose(fp);fclose(fp_bzip);return -3;}
n=fread(temp,1,m,fp);
fclose(fp); 
if(n<m) {free(temp);fclose(fp_bzip);return -4;}



my_bzip=BZ2_bzWriteOpen( &bzip_err, fp_bzip, 4, 0,30);
if(bzip_err!=BZ_OK)  {free(temp);fclose(fp_bzip);return -5;}

BZ2_bzWrite (&bzip_err, my_bzip, temp,  m);
i=bzip_err;	
BZ2_bzWriteClose (&bzip_err, my_bzip,0,&n,&m);
fclose(fp_bzip);
free(temp);
sync();
if(i!=BZ_OK || bzip_err!=BZ_OK)
	{
	remove(filename);
	 return -5;
	}
else remove(name);


return 0;
}

int save_game()
{

t_cab_sav cabsav;
int n, m;
BZFILE * my_bzip;
int bzip_err=0;
int file_error=0;
char savefile[256];
cabsav.ID=0xCACABACA;
cabsav.have=128;

for(n=8;n<0x2000;n++)
	{
	if(WRAM[n]!=0) break;
	}
if(n!=0x2000) cabsav.have|=1; // WRAM en uso

if (populus) cabsav.have|=2; // memoria extra de populus
if (CD_emulation) cabsav.have|=4; // ram de cdrom
for (n=0;n<8;n++) cabsav.CD_cmd[n]=CD_track_cmd[n]; 

for(n=0;n<8;n++)
	{
	if(Page[n]==IOAREA2) m=256;
	else
	{
	for(m=0;m<256;m++)
		{
		if(Page[n]==(ROMMap[m]-n*0x2000)) break;
		}
	}
	cabsav.page[n]=m;
	}

skip_wave_sound=1;
back_name_path[back_name_ext-1]=0;
sprintf(savefile,"%s.tmp",back_name_path);
 back_name_path[back_name_ext-1]='.';
	back_name_path[back_name_ext]='s';back_name_path[back_name_ext+1]='a';back_name_path[back_name_ext+2]='v';back_name_path[back_name_ext+3]=0;
   
	fp_bzip = fopen(/*back_name_path*/savefile, "wb");
	skip_wave_sound=0;
	if (fp_bzip == NULL)
	{return 0;}
	else
	{
		
     my_bzip=BZ2_bzWriteOpen( &bzip_err, fp_bzip, 4, 0,30);
	 if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun;}
		skip_wave_sound=1;
		BZ2_bzWrite (&bzip_err, my_bzip, &cabsav,  sizeof(cabsav));
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		if(cabsav.have & 128) BZ2_bzWrite (&bzip_err, my_bzip, MY_filename,256);
		
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		BZ2_bzWrite (&bzip_err, my_bzip, M2,  sizeof(M6502)); // salva los registros etc+
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		BZ2_bzWrite (&bzip_err, my_bzip, &io,  sizeof(io)); // salva el tema I/O 
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		
		BZ2_bzWrite (&bzip_err, my_bzip, SPRAM,64*8);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		BZ2_bzWrite (&bzip_err, my_bzip, Pal,512);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		BZ2_bzWrite (&bzip_err, my_bzip, SPM,WIDTH*HEIGHT);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		
		BZ2_bzWrite (&bzip_err, my_bzip, vchange,VRAMSIZE/32);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		BZ2_bzWrite (&bzip_err, my_bzip, vchanges,VRAMSIZE/128);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}

		BZ2_bzWrite (&bzip_err, my_bzip, VRAM,VRAMSIZE);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		BZ2_bzWrite (&bzip_err, my_bzip, VRAM2,VRAMSIZE);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		BZ2_bzWrite (&bzip_err, my_bzip, VRAMS,VRAMSIZE);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		BZ2_bzWrite (&bzip_err, my_bzip, RAM,  0x8000);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		if(cabsav.have & 1)
		     BZ2_bzWrite (&bzip_err, my_bzip, WRAM,  0x2000);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		if(cabsav.have & 2)
		     BZ2_bzWrite (&bzip_err, my_bzip, PopRAM,  0x8000);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}

		if(cabsav.have & 4) // if cdrom
		{
		BZ2_bzWrite (&bzip_err, my_bzip, cd_extra_mem,  0x10000);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		BZ2_bzWrite (&bzip_err, my_bzip, cd_extra_super_mem,  0x30000);
		if(bzip_err!=BZ_OK) {file_error=1;goto exit_fun_2;}
		
		}
	exit_fun_2:
		BZ2_bzWriteClose (&bzip_err, my_bzip,0,&n,&m);
		fclose(fp_bzip); fp_bzip=0;
		if(bzip_err!=BZ_OK) {file_error=1;}
		sync();
	}
exit_fun:
if(!file_error)
{
remove(back_name_path);
rename(savefile,back_name_path);
}
else remove(savefile);

skip_wave_sound=0;
return 1;
}

int load_game(int modo)
{

t_cab_sav cabsav;
int n, m;
BZFILE * my_bzip;
int bzip_err=0;

cabsav.have=0;


skip_wave_sound=1;
back_name_path[back_name_ext]='s';back_name_path[back_name_ext+1]='a';back_name_path[back_name_ext+2]='v';back_name_path[back_name_ext+3]=0;

	
if(modo==0) fp_bzip = fopen(back_name_path, "rb");
else
if(modo==1)	fp_bzip = fopen(MY_filename, "rb");
else fseek(fp_bzip,0,SEEK_SET); // rebobina la pelicula...
skip_wave_sound=0;
	if (fp_bzip == NULL)
		return 0;
	else
	{skip_wave_sound=1;
	my_bzip=BZ2_bzReadOpen( &bzip_err, fp_bzip, 0, 1, NULL, 0 );
		BZ2_bzRead (&bzip_err, my_bzip, &cabsav,  sizeof(cabsav));
		if(cabsav.ID!=0xCACABACA || (modo!=0 && (cabsav.have & 128)==0))
		{fclose(fp_bzip);BZ2_bzReadClose (&bzip_err, my_bzip);skip_wave_sound=0;return 0;}
		if(cabsav.have & 128) BZ2_bzRead (&bzip_err, my_bzip, MY_filename,256);
		if(modo==1) 
			{BZ2_bzReadClose (&bzip_err, my_bzip);
		    skip_wave_sound=0;return 1; // sal sin cerrar el fichero...
			 }
		BZ2_bzRead (&bzip_err, my_bzip, M2,  sizeof(M6502)); // salva los registros etc
		BZ2_bzRead (&bzip_err, my_bzip, &io,  sizeof(io)); // salva el tema I/O 
		BZ2_bzRead (&bzip_err, my_bzip, SPRAM,64*8);
		BZ2_bzRead (&bzip_err, my_bzip, Pal,512);
		BZ2_bzRead (&bzip_err, my_bzip, SPM,WIDTH*HEIGHT);

		BZ2_bzRead (&bzip_err, my_bzip, vchange,VRAMSIZE/32);
		BZ2_bzRead (&bzip_err, my_bzip, vchanges,VRAMSIZE/128);

		BZ2_bzRead (&bzip_err, my_bzip, VRAM,VRAMSIZE);
		BZ2_bzRead (&bzip_err, my_bzip, VRAM2,VRAMSIZE);
		BZ2_bzRead (&bzip_err, my_bzip, VRAMS,VRAMSIZE);
		BZ2_bzRead (&bzip_err, my_bzip, RAM,  0x8000);
		if(cabsav.have & 1)
		     BZ2_bzRead (&bzip_err, my_bzip, WRAM,  0x2000);
		if(cabsav.have & 2)
		     BZ2_bzRead (&bzip_err, my_bzip, PopRAM,  0x8000) ;

		if(cabsav.have & 4)  // if cdrom
		{
		BZ2_bzRead (&bzip_err, my_bzip, cd_extra_mem,  0x10000);
		BZ2_bzRead (&bzip_err, my_bzip, cd_extra_super_mem,  0x30000);
		for(n=0;n<8;n++) CD_track_cmd[n]=cabsav.CD_cmd[n];
		if(CD_track_cmd[0]==1) h_play_track(CD_track_cmd[1]);
		else
		if(CD_track_cmd[0]==2) h_play_sectors(CD_track_cmd[1],CD_track_cmd[2],CD_track_cmd[3]);
		
		if(CD_track_cmd[4]==4) pce_cd_read_sector_special (CD_track_cmd[5]);
		
		} 
		BZ2_bzReadClose (&bzip_err, my_bzip);
		fclose(fp_bzip);fp_bzip=0;

	for(n=0;n<8;n++)
	{
	if(cabsav.page[n]==256) Page[n]=IOAREA2;
	else Page[n]=ROMMap[cabsav.page[n]]-n*0x2000;
	}
	
	}
	
skip_wave_sound=0;
return 1;
}
void ResetPCE(M6502 *M)
{
	int i;
	memset(M,0,sizeof(*M));
	memset (SPRAM, 0, 64 * 8);
	//TimerCount = TimerPeriod;
	M->IPeriod = IPeriod;
	//M->TrapBadOps = 1;
	memset(&io, 0, sizeof(IO));
	scanline = 0;
	io.vdc_status=0;//VDC_InVBlank;
	io.vdc_inc = 1;
	io.minline = 0;
	io.maxline = 255;
	io.irq_mask = 0;
	io.psg_volume = 0;
	io.psg_ch = 0;
	io.screen_w = 255;
	io.screen_h = 224;
	for (i = 0; i < 6; i++)
	{
		io.PSG[i][4] = 0x80;
	}
	CycleOld = 0;

Reset6502(M);

 // sp_base = RAM + 0x100;
  

	
	//printf("reset PC=%04x ",M->PC.W);
}

int InitPCE(char *name)
{
	int i,ROMmask;
	FILE *fp;
	
	char *w;
	cart_name = name;

    back_name_path[0]=0;
	CD_track_cmd[0]=0;
	CD_track_cmd[4]=0;
	if (CartLoad(name)) return -1;

	memset(XBuf,0,WIDTH * HEIGHT);
	memset(Pal,0,512);
	//DMYROM=(BYTE *)malloc(0x2000);
	//memset(DMYROM,NODATA,0x2000);

	WRAM=(BYTE *)malloc(0x2000+0x2000);
	if(WRAM==NULL) return -2;
	memset(WRAM,0,0x4000);
   #if 1
	WRAM[0] = 0x48;		/* 'H' */
	WRAM[1] = 0x55;		/* 'U' */
    WRAM[2] = 0x42;		/* 'B' */
    WRAM[3] = 0x4D;		/* 'M' */
    WRAM[5] = 0xA0;		/* WRAM[4-5] = 0xA000, end of free mem ? */
    WRAM[6] = 0x10;		/* WRAM[6-7] = 0x8010, beginning of free mem ? */
    WRAM[7] = 0x80;
	#endif

	w=get_name(name);
	
	i=0;{int n; while (w[i]!=0) i++; n=i; while (w[i]!='.' && i>0) i--;	if(i<=0) i=n;}
	w[i++]='.';w[i++]='w';w[i++]='r';w[i++]='a';w[i++]=0;
    sprintf(back_name_path,"/mnt/sd/roms/pcengine/saves/%s",w);
	i=0;while (back_name_path[i]!=0) i++; back_name_ext=i-3; 
	 
	 fp = fopen (back_name_path, "rb"); // cargando memoria backup

    if (fp != NULL)
      {
	  fread (WRAM, 0x2000, 1, fp);
	  fclose (fp);
      }


	VRAM=(BYTE *)malloc(VRAMSIZE);
	if(VRAM==NULL) return -2;
	VRAM2=(unsigned long *)malloc(VRAMSIZE);
	if(VRAM2==NULL) return -2;
	VRAMS=(unsigned long *)malloc(VRAMSIZE);
	if(VRAMS==NULL) return -2;

	memset(VRAM,0,VRAMSIZE);
	memset(VRAM2,0,VRAMSIZE);
	memset(VRAMS,0,VRAMSIZE);

	IOAREA=(BYTE *)malloc(0x2000+0x2000);
	if(IOAREA==NULL) return -2;
	memset(IOAREA,0xFF,0x2000);
	//IOAREA=0;
	vchange = (BYTE *)malloc(VRAMSIZE/32);
	memset(vchange,1,VRAMSIZE/32);
	vchanges = (BYTE *)malloc(VRAMSIZE/128);
	memset(vchanges,1,VRAMSIZE/128);
	ROMmask = 1;
	while(ROMmask<ROM_size) ROMmask<<=1;
	ROMmask--;
	for(i=0;i<0x100;i++) ROMMap[0xFF]=IOAREA;
	for(i=0;i<0x80;i++)
	{
		if (ROM_size == 0x30)
		{
			switch (i&0x70)
			{
			case 0x00:
			case 0x10:
			case 0x50:
				ROMMap[i]=ROM+(i&ROMmask)*0x2000;
				break;
			case 0x20:
			case 0x60:
				ROMMap[i]=ROM+((i-0x20)&ROMmask)*0x2000;
				break;
			case 0x30:
			case 0x70:
				ROMMap[i]=ROM+((i-0x10)&ROMmask)*0x2000;
				break;
			case 0x40:
				ROMMap[i]=ROM+((i-0x20)&ROMmask)*0x2000;
				break;
			}
		}
		else
		{
			ROMMap[i]=ROM+(i&ROMmask)*0x2000;
		}
	}
//		ROMMap[i]=ROM+(i%ROM_size+i/ROM_size*0x10)*0x2000;
/*		if (((i&ROMmask)+i/(ROMmask+1)) < ROM_size)
			ROMMap[i]=ROM+((i&ROMmask)+i/(ROMmask+1)*0x20)*0x2000;
		else
			ROMMap[i]=ROM;
*///		ROMMap[i]=ROM+(i&ROMmask)*0x2000;
	if (populus)
	{
		ROMMap[0x40] = PopRAM + (0)*0x2000;
		ROMMap[0x41] = PopRAM + (1)*0x2000;
		ROMMap[0x42] = PopRAM + (2)*0x2000;
		ROMMap[0x43] = PopRAM + (3)*0x2000;
	
	}

	if (CD_emulation)
    {

      ROMMap[0x80] = cd_extra_mem;
      ROMMap[0x81] = cd_extra_mem + 0x2000;
      ROMMap[0x82] = cd_extra_mem + 0x4000;
      ROMMap[0x83] = cd_extra_mem + 0x6000;
      ROMMap[0x84] = cd_extra_mem + 0x8000;
      ROMMap[0x85] = cd_extra_mem + 0xA000;
      ROMMap[0x86] = cd_extra_mem + 0xC000;
      ROMMap[0x87] = cd_extra_mem + 0xE000;

      

      for (i = 0x68; i < 0x80; i++)
				{
					ROMMap[i] = cd_extra_super_mem + 0x2000 * (i - 0x68);
					
				}

    }
/*	ROMMap[0x80] = PopRAM + (0)*0x2000;
	ROMMap[0x81] = PopRAM + (1)*0x2000;
	ROMMap[0x82] = PopRAM + (2)*0x2000;
	ROMMap[0x83] = PopRAM + (3)*0x2000;
	ROMMap[0x84] = PopRAM + (4)*0x2000;
	ROMMap[0x85] = PopRAM + (5)*0x2000;
	ROMMap[0x86] = PopRAM + (6)*0x2000;
	ROMMap[0x87] = PopRAM + (7)*0x2000;
*/	


IOAREA2=IOAREA;
	ROMMap[0xF7]=WRAM;
	ROMMap[0xF8]=RAM;
	ROMMap[0xF9]=RAM+0x2000;
	ROMMap[0xFA]=RAM+0x4000;
	ROMMap[0xFB]=RAM+0x6000;
	ROMMap[0xFF]=IOAREA;

  if (/*(ROM[0x1FFF] < 0xE0) || */rom_need_decrypt) decrypt_rom();
    
	/*FILE *fp;
	fp = fopen(backmemname, "rb");
	if (fp == NULL)
		LogDump("Can't open %s\n", backmemname);
	else
	{
		fread(WRAM, 0x2000, 1, fp);
		fclose(fp);
	}
*/

	
	return 0;
}


SaveWRAM()
{
FILE *fp;
int n;

for(n=8;n<0x2000;n++)
	{
	if(WRAM[n]!=0) break;
	}
if(n==0x2000) return; // test if WRAM is not modified and return 

if(back_name_path[0]!=0) 
	{
	back_name_path[back_name_ext]='w';back_name_path[back_name_ext+1]='r';back_name_path[back_name_ext+2]='a';back_name_path[back_name_ext+3]=0;
	
	fp = fopen (back_name_path, "wb"); // cargando memoria backup

    if (fp != NULL)
      {
	  fwrite(WRAM, 0x2000, 1, fp);
	  fclose (fp);
	  sync();
      }
	}
}
int RunPCE(int mode)
{
	M6502 M;
	M2=&M;
	M=dummy;
	if(!mode) ResetPCE(&M);
	if(is_a_sav)
	{
	is_a_sav=0;
    if(!load_game(2)) return 1; // error cargando save game
	if(fp_bzip) fclose(fp_bzip);fp_bzip=0;
	}
	StartSound();	
	Run6502(&M);
	dummy=M;never_run_one_rom=0;
	if(watch_dog==0) SaveWRAM();
	return 1;
}

void TrashPCE()
{
	
	
	
	close_wav();

	if(iso_FILE) {fclose(iso_FILE);iso_FILE=0;}
	if (IOAREA) free(IOAREA); IOAREA=0;
	if (vchange) free(vchange); vchange=0;
	if (vchanges) free(vchanges); vchanges=0;
//	if (DMYROM) free(DMYROM);
	if (WRAM) free(WRAM);  WRAM=0;
	if (VRAM) free(VRAM);  VRAM=0;
	if (VRAM2) free(VRAM2); VRAM2=0;
	if (VRAMS) free(VRAMS); VRAMS=0;
	if (ROM) free(ROM);  ROM=0;
}

int JoyStick(void)
{
	return Joysticks();
}


int in_game=0;
void Loading_Encrypt_SCR();
extern int gp2x_speed;

int Main_Emulator(unsigned char * path_game)
{
unsigned M;
	/*BaseClock = 5000000;//7160000; //3.58-21.48;
	IPeriod = BaseClock/(scanlines_per_frame*43);
	*/
	BaseClock = 7160000;
	IPeriod = BaseClock/(scanlines_per_frame*60);



	
	
	UPeriod = 0;
	TimerPeriod = (((BaseClock/1000)*3*1024))/21480;
	
	vmode = 0;
	Debug = 0;
	
	// crea la tabla de conversion
	for(M=0;M<256;M++)
		{
		pre_tabl1[M]=((M&0x88)>>3)|((M&0x44)<<6)|((M&0x22)<<15)|((M&0x11)<<24);
	
		}

if(in_game && path_game!=NULL)
	{
	TrashPCE();TrashMachine();in_game=0;back_name_path[0]=0;
	}

	if(!in_game) 
	{
	if(path_game==NULL) {TrashMachine();return 0;} // si la cadena est vacia, retorna (esto se usa para liberar memoria)
	if(path_game[0]==0)  return;
	if (!InitMachine()) return -1;
	rom_need_decrypt=0;cart_reload=1;watch_dog=1;
    if (InitPCE(path_game)) {return 0;}
	
	}
	
		while (1)
		{
//			SetInfoString("Emulation started");
			RunPCE(in_game);
			StopSound();
			in_game=1;
			
			if (!cart_reload)
				break;
			cart_reload = 0;
			if(watch_dog) {back_name_path[0]=0;TrashPCE();in_game=0;watch_dog=1;Loading_Encrypt_SCR();} else break;

			if(InitPCE(path_game)) break;
		}
	
	
	return 0;
}






